{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: SLOWA FIBONACCIEGO                             *}
{*   Plik:                FIB.PAS                                        *}
{*   Autor:               Wojciech Rytter                                *}
{*************************************************************************}

{$M 65500,0,655360}
program SlowaFibonacciego;
 const
  LiczbaCyfr=50;
 var
  Okno1,Okno2,Wzorzec,x,y,z:string;
  l,m,n                    :longint;
  Przelacznik              :boolean;
  Plik                     :text;

  {Opis arytmetyki duzych liczb}
 type DlugaLiczba=array[1..LiczbaCyfr] of integer;
 var i,j,Pom,q1,q2:DlugaLiczba;

 procedure WypiszWynik(l:DlugaLiczba);
  var s  :string;
      i,j:integer;
 begin
  assign(Plik,'FIB.OUT');
  rewrite(Plik);
  i:=LiczbaCyfr;
  while (l[i]=0) and (i>1) do dec(i);
  for j:=i downto 1 do write(Plik,l[j]);
  writeln(Plik);
  close(Plik)
 end; {WypiszWynik}

 procedure Dodaj(var a,b,c:DlugaLiczba);
  var i,m,r,w:integer;
 begin
  r:=0;
  for i:=1 to LiczbaCyfr do begin
   w:=a[i]+b[i]+r;
   c[i]:=w mod 10;
   r:=w div 10
  end
 end; {Dodaj}

 procedure Przypisz(var y:DlugaLiczba; x:integer);
  var i,r:integer;
 begin
  for i:=1 to LiczbaCyfr do y[i]:=0;
  i:=1;
  while x<>0 do begin
   y[i]:= x mod 10;
   x:=x div 10;
   inc(i)
  end;
  writeln
 end; {Przypisz}

 {Koniec opisu wlasnej arytmetyki}

 function LiczbaWyst(y:string):longint;
   {Wartoscia funkcji jest liczba wystapien wzorca Wzorzec
    w slowie y. Wzorzec jest zmienna globalna.}
  var Licznik,p:longint;
 begin
  Licznik:=0;
  while pos(Wzorzec,y)>0 do begin
   inc(Licznik);
   delete(y,1,pos(Wzorzec,y))
  end;
  LiczbaWyst:=Licznik
 end; {LiczbaWyst}

 procedure WczytajDane;
 begin
  assign(Plik,'FIB.IN');  reset(Plik);
  readln(Plik,Wzorzec);
  readln(Plik,n);
  close(Plik)
 end; {Wczytajdane}

begin {Program glowny}
 WczytajDane;
 l:=length(Wzorzec);
  {Inicjalizacja: oblicz m, x, y}
 m:=1;  x:='b';  y:='a';
 while length(x)<l do begin
  inc(m);  z:=y;  y:=concat(y,x);  x:=z
 end;
  {Teraz x=FIB_m, y=FIB_m+1}
  {Obliczenia dla malego n}
 if n<m then Przypisz(i,0)
 else begin {Obliczenia dla duzego n}
  Przypisz(i,LiczbaWyst(x));
  Przypisz(j,LiczbaWyst(y));
  Okno1:=concat(copy(x,length(x)-l+2,l-1),copy(y,1,l-1));
  Okno2:=concat(copy(y,length(y)-l+2,l-1),copy(y,1,l-1));
  Przypisz(q1,LiczbaWyst(Okno1));
  Przypisz(q2,LiczbaWyst(Okno2));

   {Zasadnicza czesc programu}

  Przelacznik:=false;
  while m<n do begin
   Przelacznik:=not Przelacznik;
   inc(m);  Pom:=j;  Dodaj(i,j,j);  i:=Pom;
   if Przelacznik then Dodaj(j,q2,j) else Dodaj(j,q1,j)
  end {m<n}
 end;  {Koniec obliczen dla duzego n}
 WypiszWynik(i)
end. {SlowaFibonacciego}