{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: PIEC MONET                                     *}
{*   Plik:                UWAGA.PAS - modul UWAGA                        *}
{*   Autor:               Albert Krzymowski                              *}
{*************************************************************************}

unit UWaga;
 interface
  uses UMoneta;

  function Lzejsza(m1,m2:TMoneta):boolean;
    { funkcja z tresci zadania }

  procedure Wynik(m1,m2,m3,m4,m5:TMoneta);
    { musi zostac wywolana dokladnie jeden raz }

 { --------------------------------------------------- }

  procedure WagaKolejnosc(m1,m2,m3,m4,m5:TMoneta);
   var IleRazyWynik:integer;

{***************************************************************************}

 implementation
   var
    InvPer  :array[TMoneta] of 1..5; { inwersja permutacji jest wygodniejsza}
    IlePytan:integer;
{***************************************************************************}
{  WagaUstaw - ustala permutacje, na ktorej bedziemy testowac               }
{***************************************************************************}

   procedure WagaKolejnosc(m1,m2,m3,m4,m5:TMoneta);
   begin
    InvPer[m1]:=1;
    InvPer[m2]:=2;
    InvPer[m3]:=3;
    InvPer[m4]:=4;
    InvPer[m5]:=5;
    IlePytan:=0;
    IleRazyWynik:=0
   end; {WagaKolejnosc}

{***************************************************************************}
{ Lzejsza - funkcje z zadania, wyniku = true == Waga(m1) < Waga(m2)         }
{***************************************************************************}

   function Lzejsza(m1,m2:TMoneta):boolean;
   begin
    inc(IlePytan);
    write('Porownanie nr: ',IlePytan,'. ');
    write('Czy ',MonetaToStr(m1),' < ',MonetaToStr(m2),' ? ');
    if InvPer[m1]<InvPer[m2] then begin
     Lzejsza:=true;
     writeln('Tak.')
    end
    else begin
     Lzejsza:=false;
     writeln('Nie')
    end;
    if IlePytan>10 then begin
     writeln('Wszystkich mozlosci porownan jest 10, to jest juz 11.');
     writeln('Przerywam testowanie.');
     halt(0)
    end
   end; {Lzejsza}

{***************************************************************************}
{ Wynik - przez ta procedure zawodnik podaje odpowiedz.                     }
{  Musi zostac wywolana dokladnie jeden raz.                                }
{***************************************************************************}
   procedure Wynik(m1,m2,m3,m4,m5:TMoneta);
   begin
    writeln;
    writeln('Podano wynik: ',MonetyToStr(m1,m2,m3,m4,m5),'. ');
    inc(IleRazyWynik);
    if IleRazyWynik=1 then
     if (InvPer[m1]=1) and
          (InvPer[m2]=2) and
          (InvPer[m3]=3) and
          (InvPer[m4]=4) and
          (InvPer[m5]=5) then writeln('Brawo !!! Dobra odpowiedz.')
                         else writeln('Niestety, zla odpowiedz.')
    else
     writeln('Procedure wynik wywolano wiecej niz jeden raz !')
   end; {Wynik}

begin
end. {unit UWaga}
