{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: WIEZE                                          *}
{*   Plik:                WIE.PAS                                        *}
{*   Autor:               Krzysztof Diks                                 *}
{*************************************************************************}

{$M 65500,0,655360}
program Wieze;
 const
  MaksN     =3000; {MaksN*MaksN --- maksymalny rozmiar szachownicy}
  MaksNPlus1=MaksN+1;
 type
  Przedzial =record
              Pocz,Kon,NrPrzedz:1..MaksNPlus1
             end;
  Przedzialy=array[0..MaksNPlus1] of Przedzial;
  Ustawienie=array[1..MaksN] of 1..MaksN;

  {Operacje na kopcu zawierajacym przedzialy uporzadkowane wg. koncow.}

 procedure WstawPrzedzial(var Kopiec:Przedzialy; var r:Integer;
                          NowyPrzedzial:Przedzial);
   {Wstawienie NowyPrzedzial do kopca; r jest aktualna liczba elementow
    w kopcu.}
  var i:integer;
 begin
  r:=r+1;  i:=r;
  Kopiec[0]:=NowyPrzedzial; {Straznik dla przypadku i div 2=0.}
  while NowyPrzedzial.Kon<Kopiec[i div 2].Kon do begin
   Kopiec[i]:=Kopiec[i div 2];
   i:=i div 2
  end;
  Kopiec[i]:=NowyPrzedzial
 end; {WstawPrzedzial}

 procedure UsunMin(var Kopiec:Przedzialy; var r:integer);
   {Usuniecie z kopca przedzialu z najmniejszym koncem;
    r jest liczba elementow w kopcu.}
  var
   i,j            :integer;
   Przedz         :Przedzial;
   PorzadekKopcowy:boolean;
 begin
  Przedz:=Kopiec[r];  r:=r-1;
  i:=1;  j:=2;
  PorzadekKopcowy:=false;
  while (j<=r) and not PorzadekKopcowy do begin
   if j<r then
    if Kopiec[j].Kon>Kopiec[j+1].Kon then j:=j+1;
   if Przedz.Kon<=Kopiec[j].Kon then PorzadekKopcowy:=true
   else begin Kopiec[i]:=Kopiec[j];  i:=j;  j:=2*i end
  end; {while }
  Kopiec[i]:=Przedz
 end; {UsunMin}

  {Sortowanie, metoda przez zliczanie, przedzialow wg. poczatkow.}

 procedure UporzadkujPrzedzialy(var Przedz:Przedzialy; l:integer);
   {l-liczba przedzialow do uporzadkowania; przedzialy sa
    zawarte w przedziale [1,l].}
  var
   Liczniki:array[1..MaksN] of integer;
   Pom     :Przedzialy;
   i       :integer;
 begin
   {Wyznaczamy Liczniki[i] - ile jest przedzialow o poczatkach <= i.}
  for i:=1 to l do Liczniki[i]:=0;
  for i:=1 to l do
   Liczniki[Przedz[i].Pocz]:=Liczniki[Przedz[i].Pocz]+1;
  for i:=2 to l do
   Liczniki[i]:=Liczniki[i]+Liczniki[i-1];
   {Liczniki[i] - pozycja po posortowaniu ostatniego przedzialu o
    poczatku w i.}
   {Przegladaj przedzialy i umieszczaj przedzialy o tym samym poczatku p
    w tablicy Pom kolejno na pozycjach Liczniki[p], Liczniki[p-1] itd.}
  for i:=1 to l do begin
   Pom[Liczniki[Przedz[i].Pocz]]:=Przedz[i];
   Liczniki[Przedz[i].Pocz]:=Liczniki[Przedz[i].Pocz]-1
  end;
  for i:=1 to l do Przedz[i]:=Pom[i]
 end; {UporzadkujPrzedzialy}

  {Wyznaczanie ustawienia.}

 procedure Ustaw(var u:Ustawienie; var P:Przedzialy;
                 l:integer; var JestUstawienie:boolean);
   {Wyznaczanie ustawienia u dla l przedzialow ze zbioru P;
    po wykonaniu Ustaw takie ustawienie istnieje i znajduje sie
    w tablicy u wtedy i tylko wtedy, gdy JestUstawienie=true.}
  var
   i,j,lQ:integer;  {lQ - liczba elementow w Q.}
   Q     :Przedzialy;
 begin
  UporzadkujPrzedzialy(p,l);
  lQ:=0;
  JestUstawienie:=true;
  i:=1;  j:=0;
  P[l+1].Pocz:=l+1; {Straznik}
  while JestUstawienie and (j<l) do begin
   j:=j+1;
   while P[i].Pocz=j do begin
    WstawPrzedzial(Q,lQ,P[i]);
    i:=i+1
   end;
   if lQ=0 {Zbior Q jest pusty.} then JestUstawienie:=false
   else begin {(2) - przedzial z najmniejszym koncem jest w korzeniu kopca.}
    u[Q[1].NrPrzedz]:=j;
    UsunMin(Q,lQ);   { (3) }
    if lQ<>0 then JestUstawienie:=Q[1].Kon>j { (4) }
   end {else}
  end {while JestUstawienie }
 end; {Ustaw}

  {Program glowny}

 var
  Poziome,Pionowe            :Przedzialy;
  n                          :1..MaksN;
  UstWWierszach,UstWKolumnach:Ustawienie;
  JestUstawienie             :boolean;
  f                          :text;
  i                          :integer;
begin
 assign(f,'WIE.IN');
 reset(f);
 readln(f,n);
 for i:=1 to n do begin
  readln(f,Pionowe[i].Pocz,Poziome[i].Pocz,Pionowe[i].Kon,Poziome[i].Kon);
  Pionowe[i].NrPrzedz:=i;
  Poziome[i].NrPrzedz:=i
 end;
 close(f);
  {Ustawianie wiez}
   {Ustawianie w wierszach}
 Ustaw(UstWWierszach,Pionowe,n,JestUstawienie);
 if JestUstawienie then
   {Ustawianie w kolumnach}
  Ustaw(UstWKolumnach,Poziome,n,JestUstawienie);
   {Wypisanie wynikow}
 assign(f,'WIE.OUT');
 rewrite(f);
 if JestUstawienie then
  for i:=1 to n do
   writeln(f,UstWWierszach[i],' ',UstWKolumnach[i])
 else writeln(f,'NIE');
 close(f)
end. {Wieze}
